#include "FdSerial.h"
#include "propeller.h"

static HUB FdSerial_t serialData;

static int serial_inbyte(void);
static void serial_outbyte(int ch);

int InitSerialTerm(int rxpin, int txpin, int mode, int baudrate, int flags)
{
	int ret;
    if ((ret = FdSerial_start(&serialData, rxpin, txpin, mode, baudrate)) != 0) {
		if (flags & TERM_IN)
			term_inbyte_ptr = serial_inbyte;
		if (flags & TERM_OUT)
			term_outbyte_ptr = serial_outbyte;
	}
	return ret;
}

static int serial_inbyte(void)
{
	return FdSerial_rx(&serialData);
}

static void serial_outbyte(int ch)  
{
    FdSerial_tx(&serialData, ch);
}
