#include <stdio.h>
#include <setjmp.h>
#include <string.h>
#include "TvTileGfx.h"
#include "propeller.h"

HUB TvTileGfx_st params;
HUB uint16_t tile_map[TV_TILE_GFX_COL_CNT * TV_TILE_GFX_ROW_CNT];
HUB uint16_t tiles[TV_TILE_GFX_C64_FONT_TILE_CNT * TV_TILE_GFX_TILE_SIZE];
HUB uint32_t palettes[TV_TILE_GFX_C64_PALETTE_CNT];

int main(void)
{
	int row, col;
	uint16_t *p;

	iprintf("initializing\n");
	longfill((uint32_t *)tile_map, 0, sizeof(tile_map) / sizeof(uint32_t));
	longmove_swapwords((uint32_t *)tiles, (uint32_t *)c64_8x8_font, TV_TILE_GFX_C64_FONT_TILE_CNT * TV_TILE_GFX_TILE_SIZE / sizeof(uint32_t));
	longmove(palettes, c64_palettes, TV_TILE_GFX_C64_PALETTE_CNT);

	iprintf("filling\n");
	for (p = tile_map, row = 0; row < TV_TILE_GFX_ROW_CNT; ++row)
		for (col = 0; col < TV_TILE_GFX_COL_CNT; ++col)
			*p++ = 0x20 + row + col;

    iprintf("starting tile graphics driver\n");
	params.tile_map_base_ptr_parm = (uint16_t *)PhysicalHubAddress(tile_map);
	params.tile_bitmaps_base_ptr_parm = (uint16_t *)PhysicalHubAddress(tiles);
	params.tile_palettes_base_ptr_parm = (uint32_t *)PhysicalHubAddress(palettes);
	params.tile_map_control_parm = c64_control;
	TvTileGfx_start(&params, tvPin);

    return 0;
}

