#include <stdio.h>
#include "propeller.h"

#define LED_MASK    (1 << 15)

void waitcnt(int cnt)
{
    while (--cnt >= 0)
        ;
}

int main(void)
{
    int repeat, ch;
	
	// the traditional first test program
	iprintf("Hello, world!\n");
    
	// show propeller register access
	iprintf("CLKFREQ: %lu\n", CLKFREQ);
    iprintf("CNT %08x\n", CNT);
    iprintf("CNT %08x\n", CNT);
    iprintf("cogid() = %d\n", cogid());

	// blink the LED on the C3 a few times
#ifdef BOARD_C3
    DIRA |= LED_MASK;
	OUTA |= LED_MASK;
    repeat = 10;
	while (--repeat >= 0) {
        OUTA ^= LED_MASK;
        waitcnt(10000);
    }
#endif

	// echo characters using stdin and stdout
    while ((ch = getchar()) != -1)
        putchar(ch);

    return 0;
}
